Index: main/waeup.aaue/trunk/src/waeup/aaue/interswitch/browser.py
===================================================================
--- main/waeup.aaue/trunk/src/waeup/aaue/interswitch/browser.py	(revision 17430)
+++ main/waeup.aaue/trunk/src/waeup/aaue/interswitch/browser.py	(revision 17431)
@@ -246,410 +180,129 @@
             self.redirect(self.url(self.context, '@@index'))
             return
-        self.context.r_company = u'interswitch'
+        category = self.context.p_category
+        # Already now it becomes an Interswitch payment. We set the net amount
+        # and add the gateway amount.
+        if not self.context.r_company:
+            self.context.net_amt = self.context.amount_auth
+            self.context.amount_auth += GATEWAY_AMT
+            self.context.gateway_amt = GATEWAY_AMT
+            self.context.r_company = u'interswitch'
         student = self.student
-        p_session = self.context.p_session
-        try:
-            academic_session = grok.getSite()['configuration'][str(p_session)]
-        except KeyError:
-            self.flash(_(u'Session configuration object is not available.'),
-                       type='danger')
-            self.redirect(self.url(self.context, '@@index'))
-            return
-        if contr_agreement_student(student) == 'first':
-            self.product_id = PRODUCT_ID_PT
-            self.mac = MAC_PT
-        else:
-            self.product_id = PRODUCT_ID_REGULAR
-            self.mac = MAC_REGULAR
-
-        # To guarantee that cleared students pay both acceptance fee
-        # and school fees, the page can only be accessed
-        # for school fee payments if acceptance/clearance fee has
-        # been successfully queried/paid beforehand. This
-        # requirement applies to students in state 'cleared' and
-        # entry_session greater than 2012 only.
-        if self.context.p_category.startswith('schoolfee') and \
-            student.state == CLEARED and \
-            student.entry_session > 2012:
-            acceptance_fee_paid = False
-            for ticket in student['payments'].values():
-                if ticket.p_state == 'paid' and \
-                    ticket.p_category.startswith('clearance'):
-                    acceptance_fee_paid = True
-                    break
-            if not acceptance_fee_paid:
-                self.flash(
-                    _('Please pay acceptance fee first.'), type="danger")
-                self.redirect(self.url(self.context, '@@index'))
-                return
-
         xmldict = self.xmldict
-        xmltext = ""
-        xmldict['institution_acct'] = '1010827641'
-        xmldict['institution_bank_id'] = '117'
+        # Provider data
         xmldict['detail_ref'] = self.context.p_id
         xmldict['provider_acct'] = PROVIDER_ACCT
         xmldict['provider_bank_id'] = PROVIDER_BANK_ID
         xmldict['provider_item_name'] = PROVIDER_ITEM_NAME
-        xmldict['institution_item_name'] = self.category
+        # Institution data
+        xmldict['institution_acct'] = '00000000'
+        xmldict['institution_bank_id'] = '00'
+        provider_amt = 0.0
+        if category.startswith('clearance'):
+            provider_amt = 1500.0
+        elif category.startswith('hostel_maintenance'):
+            provider_amt = 1000.0
+        elif category in ('schoolfee', 'schoolfee_1', 'schoolfee_incl'):
+            provider_amt = 2500.0
+        xmldict['provider_amt'] = 100 * provider_amt
+        xmldict['institution_item_name'] = self.context.category
         xmldict['institution_name'] = INSTITUTION_NAME
-        provider_amt = 0.0
-        xmldict['institution_amt'] = 100 * (
-            gateway_net_amt(self.context.amount_auth))
-
-        # Schoolfee
-        if self.context.p_category.startswith('schoolfee'):
-            if contr_agreement_student(student) == 'first':
-                # First agreement
-                provider_amt = 1900.0
-                joint_venture_amt = 0.0
-                aaue_share_amt = 0.0
-                student_union_due_amt = gateway_net_amt(
-                    academic_session.union_fee)
-                student_welfare_assurance_amt = gateway_net_amt(
-                    academic_session.welfare_fee)
-                sports_amt = gateway_net_amt(
-                    academic_session.sports_fee)
-                library_amt = gateway_net_amt(
-                    academic_session.library_fee)
-                library_amt_pg = gateway_net_amt(
-                    academic_session.library_pg_fee)
-                lms_sund_amt = gateway_net_amt(
-                    academic_session.lms_sund_fee)
-                xmldict['student_union_bank_id'] = '31'
-                xmldict['student_union_acct'] = '0051005007'
-                xmldict['aaue_share_bank_id'] = '117'
-                xmldict['aaue_share_acct'] = '1010827641'
-                xmldict['joint_venture_bank_id'] = '117'
-                xmldict['joint_venture_acct'] = '1010827641'
-                xmldict['institution_acct'] = '1014847058'
-                xmldict['institution_bank_id'] = '7'
-                self.pay_item_id = '105'
-                if student.current_mode == 'found':
-                    self.pay_item_id = '103'
-                elif student.current_mode == 'ijmbe':
-                    self.pay_item_id = '103'
-                    xmldict['institution_bank_id'] = '123'
-                    xmldict['institution_acct'] = '1012278272'
+        xmldict['institution_amt'] = 100 * self.context.net_amt
+        if not self.context.provider_amt:
+            self.context.provider_amt = provider_amt
+            self.context.amount_auth += provider_amt
+        xmltext = ''
+
+        # School fee
+        if category.startswith('schoolfee'):
+            # collect additional fees
+            if self.context.p_category in ('schoolfee_1', 'schoolfee_incl'):
+                xmltext = """<payment_item_detail>
+<item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">""" % xmldict
+                item_id = 1
+                for item in SCHOOLFEES[student.certcode].items():
+                    try:
+                        item_amt = 100 * int(item[1])
+                        if self.context.p_category == 'schoolfee_1' and item[0] == 'tuition':
+                            item_amt /= 2
+                        acct_num = ''
+                        bank_id = ''
+                        item_name = ''
+                        # Find appropriate bank
+                        try:
+                            bank = BANK_ACCOUNTS[item[0]]
+                        except: # transfer to faculty account
+                            if student.faccode in ('FAG', 'FAT', 'FBM', 'FMLS', 'fac1'):
+                                bank = BANK_ACCOUNTS['fac1']
+                            elif student.faccode in ('FCS', 'FED', 'FES', 'FET'):
+                                bank = BANK_ACCOUNTS['fac2']
+                            elif student.faccode in ('FLS', 'FLW', 'FMS', 'FPS', 'FSS'):
+                                bank = BANK_ACCOUNTS['fac3']
+                        acct_num = bank[0]
+                        bank_id = bank[1]
+                        item_name = "%s (%s)" % (bank[2], item[0])
+                        xmltext += """
+<item_detail item_id="%s" item_name="%s" item_amt="%d" bank_id="%s" acct_num="%s" />""" % (item_id, item_name, item_amt, bank_id, acct_num)
+                        item_id += 1
+                    except:
+                        pass
+                xmldict['item_id'] = item_id
+                xmltext += """
+<item_detail item_id="%(item_id)d" item_name="%(provider_item_name)s" item_amt="%(provider_amt)d" bank_id="%(provider_bank_id)s" acct_num="%(provider_acct)s" />
+</item_details>
+</payment_item_detail>""" % xmldict
+            # no additional charges, determine faculty bank only
             else:
-                # Second agreement
-                joint_venture_amt = 1000.0
-                aaue_share_amt = 1500.0
-                provider_amt = 1500.0
-                student_union_due_amt = gateway_net_amt(
-                    academic_session.union_fee)
-                student_welfare_assurance_amt = gateway_net_amt(
-                    academic_session.welfare_fee)
-                sports_amt = gateway_net_amt(
-                    academic_session.sports_fee)
-                library_amt = gateway_net_amt(
-                    academic_session.library_fee)
-                library_amt_pg = gateway_net_amt(
-                    academic_session.library_pg_fee)
-                lms_sund_amt = gateway_net_amt(
-                    academic_session.lms_sund_fee)
-                xmldict['student_union_bank_id'] = '7'
-                xmldict['student_union_acct'] = '1019763348'
-                xmldict['aaue_share_bank_id'] = '117'
-                xmldict['aaue_share_acct'] = '1010827641'
-                xmldict['joint_venture_bank_id'] = '117'
-                xmldict['joint_venture_acct'] = '1010827641'
-                self.pay_item_id = '107'
-                if student.is_postgrad:
-                    self.pay_item_id = '111'
-                    xmldict['institution_acct'] = '5210006575'
-                    xmldict['institution_bank_id'] = '51'
-
-            xmldict['provider_amt'] = 100 * provider_amt
-            xmldict['joint_venture_amt'] = 100 * joint_venture_amt
-            xmldict['aaue_share_amt'] = 100 * aaue_share_amt
-            xmldict['lms_sund_amt'] = 100 * lms_sund_amt
-            if self.context.p_item == 'Balance':
-                xmldict['institution_amt'] = 100 * (
-                    gateway_net_amt(self.context.amount_auth))
-            elif self.context.p_category == 'schoolfee_2':
-                xmldict['institution_amt'] = 100 * gateway_net_amt(
-                    self.context.amount_auth)
+                if student.faccode in ('FAG', 'FAT', 'FBM', 'FMLS', 'fac1'):
+                    bank = BANK_ACCOUNTS['fac1']
+                elif student.faccode in ('FCS', 'FED', 'FES', 'FET'):
+                    bank = BANK_ACCOUNTS['fac2']
+                elif student.faccode in ('FLS', 'FLW', 'FMS', 'FPS', 'FSS'):
+                    bank = BANK_ACCOUNTS['fac3']
+                xmldict['institution_acct'] = bank[0]
+                xmldict['institution_bank_id'] = bank[1]
+
+
+        # Clearance (acceptance) fee
+
+        if category.startswith('clearance'):
+            # collect additional fees
+            if self.context.p_category == 'clearance_incl':
                 xmltext = """<payment_item_detail>
+<item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">""" % xmldict
+                item_id = 1
+                for item in ACCEPTANCEFEES[student.certcode].items():
+                    try:
+                        item_amt = 100 * int(item[1])
+                        bank = BANK_ACCOUNTS[item[0]]
+                        acct_num = bank[0]
+                        bank_id = bank[1]
+                        item_name = "%s (%s)" % (bank[2], item[0])
+                        xmltext += """
+<item_detail item_id="%s" item_name="%s" item_amt="%d" bank_id="%s" acct_num="%s" />""" % (item_id, item_name, item_amt, bank_id, acct_num)
+                        item_id += 1
+                    except:
+                        pass
+                xmldict['item_id'] = item_id
+                xmltext += """
+<item_detail item_id="%(item_id)d" item_name="%(provider_item_name)s" item_amt="%(provider_amt)d" bank_id="%(provider_bank_id)s" acct_num="%(provider_acct)s" />
+</item_details>
+</payment_item_detail>""" % xmldict
+            # no additional charges, determine faculty bank only
+            else:
+                bank = BANK_ACCOUNTS['acceptance']
+                xmldict['institution_acct'] = bank[0]
+                xmldict['institution_bank_id'] = bank[1]
+
+        # Other fees
+
+
+        if not xmltext and provider_amt == 0:
+            xmltext = """<payment_item_detail>
 <item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
 <item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
 </item_details>
 </payment_item_detail>""" % xmldict
-            elif self.context.p_category in ('schoolfee_incl', 'schoolfee_1') \
-                and student.current_mode != 'ijmbe':
-                # Schoolfee including additional fees
-                xmldict['student_union_due_amt'] = 100 * student_union_due_amt
-                xmldict['student_welfare_assurance_amt'] = 100 * student_welfare_assurance_amt
-
-                if student.entry_session >= 2018 and student.is_fresh:
-                    xmldict['sports_amt'] = 100 * sports_amt
-                    if student.is_postgrad:
-                        xmldict['library_amt'] = 100 * library_amt_pg
-                    else:
-                        xmldict['library_amt'] = 100 * library_amt
-                    xmldict['institution_amt'] = 100 * (
-                        gateway_net_amt(self.context.amount_auth)
-                        - provider_amt
-                        - student_union_due_amt
-                        - student_welfare_assurance_amt
-                        - sports_amt
-                        - library_amt
-                        - lms_sund_amt)
-                    xmltext = """<payment_item_detail>
-<item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
-<item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
-<item_detail item_id="2" item_name="%(provider_item_name)s" item_amt="%(provider_amt)d" bank_id="%(provider_bank_id)s" acct_num="%(provider_acct)s" />
-<item_detail item_id="3" item_name="Student Union" item_amt="%(student_union_due_amt)d" bank_id="%(student_union_bank_id)s" acct_num="%(student_union_acct)s" />
-<item_detail item_id="4" item_name="Student Welfare Assurance" item_amt="%(student_welfare_assurance_amt)d" bank_id="123" acct_num="1006407792" />
-<item_detail item_id="5" item_name="Sports Development Fee" item_amt="%(sports_amt)d" bank_id="123" acct_num="1006407792" />
-<item_detail item_id="6" item_name="Library Development Fee" item_amt="%(library_amt)d" bank_id="8" acct_num="2000122995" />
-</item_details>
-</payment_item_detail>""" % xmldict
-                    if contr_agreement_student(student) == 'second':
-                        xmldict['institution_amt'] = 100 * (
-                            gateway_net_amt(self.context.amount_auth)
-                            - provider_amt
-                            - joint_venture_amt
-                            - aaue_share_amt
-                            - student_union_due_amt
-                            - student_welfare_assurance_amt
-                            - sports_amt
-                            - library_amt) 
-                        xmltext = """<payment_item_detail>
-<item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
-<item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
-<item_detail item_id="2" item_name="%(provider_item_name)s" item_amt="%(provider_amt)d" bank_id="%(provider_bank_id)s" acct_num="%(provider_acct)s" />
-<item_detail item_id="3" item_name="Student Union" item_amt="%(student_union_due_amt)d" bank_id="%(student_union_bank_id)s" acct_num="%(student_union_acct)s" />
-<item_detail item_id="4" item_name="Student Welfare Assurance" item_amt="%(student_welfare_assurance_amt)d" bank_id="123" acct_num="1006407792" />
-<item_detail item_id="5" item_name="Sports Development Fee" item_amt="%(sports_amt)d" bank_id="123" acct_num="1006407792" />
-<item_detail item_id="6" item_name="Library Development Fee" item_amt="%(library_amt)d" bank_id="8" acct_num="2000122995" />
-<item_detail item_id="7" item_name="Joint Venture" item_amt="%(joint_venture_amt)d" bank_id="%(joint_venture_bank_id)s" acct_num="%(joint_venture_acct)s" />
-<item_detail item_id="8" item_name="AAUE Share" item_amt="%(aaue_share_amt)d" bank_id="%(aaue_share_bank_id)s" acct_num="%(aaue_share_acct)s" />
-</item_details>
-</payment_item_detail>""" % xmldict
-
-                    if student.entry_session >= 2021 and student.current_mode == 'ug_ft':
-                        xmldict['institution_amt'] = 100 * (
-                            gateway_net_amt(self.context.amount_auth)
-                            - provider_amt
-                            - joint_venture_amt
-                            - aaue_share_amt
-                            - student_union_due_amt
-                            - student_welfare_assurance_amt
-                            - sports_amt
-                            - library_amt
-                            - lms_sund_amt)  
-                        xmltext = """<payment_item_detail>
-<item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
-<item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
-<item_detail item_id="2" item_name="%(provider_item_name)s" item_amt="%(provider_amt)d" bank_id="%(provider_bank_id)s" acct_num="%(provider_acct)s" />
-<item_detail item_id="3" item_name="Student Union" item_amt="%(student_union_due_amt)d" bank_id="%(student_union_bank_id)s" acct_num="%(student_union_acct)s" />
-<item_detail item_id="4" item_name="Student Welfare Assurance" item_amt="%(student_welfare_assurance_amt)d" bank_id="123" acct_num="1006407792" />
-<item_detail item_id="5" item_name="Sports Development Fee" item_amt="%(sports_amt)d" bank_id="123" acct_num="1006407792" />
-<item_detail item_id="6" item_name="Library Development Fee" item_amt="%(library_amt)d" bank_id="8" acct_num="2000122995" />
-<item_detail item_id="7" item_name="Joint Venture" item_amt="%(joint_venture_amt)d" bank_id="%(joint_venture_bank_id)s" acct_num="%(joint_venture_acct)s" />
-<item_detail item_id="8" item_name="AAUE Share" item_amt="%(aaue_share_amt)d" bank_id="%(aaue_share_bank_id)s" acct_num="%(aaue_share_acct)s" />
-<item_detail item_id="9" item_name="LMS plus Sundry Fees" item_amt="%(lms_sund_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
-</item_details>
-</payment_item_detail>""" % xmldict
-
-                else:
-                    xmldict['institution_amt'] = 100 * (
-                        gateway_net_amt(self.context.amount_auth)
-                        - provider_amt
-                        - student_union_due_amt
-                        - student_welfare_assurance_amt)
-                    xmltext = """<payment_item_detail>
-<item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
-<item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
-<item_detail item_id="2" item_name="%(provider_item_name)s" item_amt="%(provider_amt)d" bank_id="%(provider_bank_id)s" acct_num="%(provider_acct)s" />
-<item_detail item_id="3" item_name="Student Union" item_amt="%(student_union_due_amt)d" bank_id="%(student_union_bank_id)s" acct_num="%(student_union_acct)s" />
-<item_detail item_id="4" item_name="Student Welfare Assurance" item_amt="%(student_welfare_assurance_amt)d" bank_id="123" acct_num="1006407792" />
-</item_details>
-</payment_item_detail>""" % xmldict
-                    if contr_agreement_student(student) == 'second':
-                        xmldict['institution_amt'] = 100 * (
-                            gateway_net_amt(self.context.amount_auth)
-                            - provider_amt
-                            - joint_venture_amt
-                            - aaue_share_amt
-                            - student_union_due_amt
-                            - student_welfare_assurance_amt)                    
-                        xmltext = """<payment_item_detail>
-<item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
-<item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
-<item_detail item_id="2" item_name="%(provider_item_name)s" item_amt="%(provider_amt)d" bank_id="%(provider_bank_id)s" acct_num="%(provider_acct)s" />
-<item_detail item_id="3" item_name="Student Union" item_amt="%(student_union_due_amt)d" bank_id="%(student_union_bank_id)s" acct_num="%(student_union_acct)s" />
-<item_detail item_id="4" item_name="Student Welfare Assurance" item_amt="%(student_welfare_assurance_amt)d" bank_id="123" acct_num="1006407792" />
-<item_detail item_id="5" item_name="Joint Venture" item_amt="%(joint_venture_amt)d" bank_id="%(joint_venture_bank_id)s" acct_num="%(joint_venture_acct)s" />
-<item_detail item_id="6" item_name="AAUE Share" item_amt="%(aaue_share_amt)d" bank_id="%(aaue_share_bank_id)s" acct_num="%(aaue_share_acct)s" />
-</item_details>
-</payment_item_detail>""" % xmldict
-
-            elif contr_agreement_student(student) == 'second':
-                # Schoolfee without Student Union Fee ands Student Welfare Assurance
-                xmldict['institution_amt'] = 100 * (
-                    gateway_net_amt(self.context.amount_auth)
-                    - provider_amt
-                    - joint_venture_amt
-                    - aaue_share_amt)
-                xmltext = """<payment_item_detail>
-<item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
-<item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
-<item_detail item_id="2" item_name="%(provider_item_name)s" item_amt="%(provider_amt)d" bank_id="%(provider_bank_id)s" acct_num="%(provider_acct)s" />
-<item_detail item_id="3" item_name="Joint Venture" item_amt="%(joint_venture_amt)d" bank_id="%(joint_venture_bank_id)s" acct_num="%(joint_venture_acct)s" />
-<item_detail item_id="4" item_name="AAUE Share" item_amt="%(aaue_share_amt)d" bank_id="%(aaue_share_bank_id)s" acct_num="%(aaue_share_acct)s" />
-</item_details>
-</payment_item_detail>""" % xmldict
-            else:
-                xmldict['institution_amt'] = 100 * (
-                    gateway_net_amt(self.context.amount_auth)
-                    - provider_amt)
-                xmltext = """<payment_item_detail>
-<item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
-<item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
-<item_detail item_id="2" item_name="%(provider_item_name)s" item_amt="%(provider_amt)d" bank_id="%(provider_bank_id)s" acct_num="%(provider_acct)s" />
-</item_details>
-</payment_item_detail>""" % xmldict
-
-        # Clearance
-        elif self.context.p_category.startswith('clearance'):
-            xmldict['institution_acct'] = '1010835352'
-            provider_amt = 0.0
-            if contr_agreement_student(student) == 'first':
-                # First agreement
-                xmldict['institution_acct'] = '1014847058'
-                xmldict['institution_bank_id'] = '7'
-                self.pay_item_id = '104'
-                if student.current_mode == 'found':
-                    self.pay_item_id = '102'
-                elif student.current_mode == 'ijmbe':
-                    self.pay_item_id = '102'
-                    xmldict['institution_bank_id'] = '123'
-                    xmldict['institution_acct'] = '1012278272'
-            else:
-                # Second agreement
-                self.pay_item_id = '102'
-                if student.is_postgrad:
-                    self.pay_item_id = '110'
-                    xmldict['institution_acct'] = '5210006575'
-                    xmldict['institution_bank_id'] = '51'
-                # ivama: Acceptance fee split is unique to "ug_ft"
-                # The reason for split is perculiar to them only...
-                # That amount was deducted from UTME application fee because
-                # some regulatory body have pegged the application fee which
-                # didn't affect another programmes.
-                if student.current_mode == 'ug_ft':
-                    provider_amt = 1500.0
-            xmldict['provider_amt'] = 100 * provider_amt
-            if self.context.p_category.endswith('_incl'):
-                # Clearance including additional fees
-                gown_fee_amt = gateway_net_amt(academic_session.matric_gown_fee)
-                aaue_lf_fee_amt = gateway_net_amt(academic_session.lapel_fee)
-                xmldict['gown_fee_amt'] = 100 * gown_fee_amt
-                xmldict['aaue_lf_fee_amt'] = 100 * aaue_lf_fee_amt
-                xmldict['institution_amt'] = 100 * (
-                    gateway_net_amt(self.context.amount_auth)
-                    - gown_fee_amt
-                    - aaue_lf_fee_amt
-                    - provider_amt)
-                xmltext = """<payment_item_detail>
-<item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
-<item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
-<item_detail item_id="2" item_name="Matriculation Gown Fee" item_amt="%(gown_fee_amt)d" bank_id="117" acct_num="1010835352" />
-<item_detail item_id="3" item_name="AAU File-Lapel Fee" item_amt="%(aaue_lf_fee_amt)d" bank_id="117" acct_num="1010835352" />""" % xmldict
-                if provider_amt:
-                    xmltext += """"
-<item_detail item_id="4" item_name="%(provider_item_name)s" item_amt="%(provider_amt)d" bank_id="%(provider_bank_id)s" acct_num="%(provider_acct)s" />
-</item_details>
-</payment_item_detail>""" % xmldict
-                else:
-                    xmltext += """"
-</item_details>
-</payment_item_detail>"""
-
-            elif student.current_mode == 'bridge':
-                # Clearance without any surcharge
-                xmldict['institution_amt'] = 100 * gateway_net_amt(
-                    self.context.amount_auth)
-                xmltext = """<payment_item_detail>
-<item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
-<item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />
-</item_details>
-</payment_item_detail>""" % xmldict
-
-            else:
-                # Clearance without additional fees
-                xmldict['institution_amt'] = 100 * (
-                    gateway_net_amt(self.context.amount_auth)
-                    - provider_amt)
-                xmltext = """<payment_item_detail>
-<item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
-<item_detail item_id="1" item_name="%(institution_item_name)s" item_amt="%(institution_amt)d" bank_id="%(institution_bank_id)s" acct_num="%(institution_acct)s" />""" % xmldict
-                if provider_amt:
-                        xmltext += """"
-<item_detail item_id="2" item_name="%(provider_item_name)s" item_amt="%(provider_amt)d" bank_id="%(provider_bank_id)s" acct_num="%(provider_acct)s" />
-</item_details>
-</payment_item_detail>""" % xmldict
-                else:
-                        xmltext += """"
-</item_details>
-</payment_item_detail>""" 
-
-        # Union Dues
-        elif self.context.p_category == 'union':
-            self.pay_item_id = '103'
-            xmldict['institution_amt'] = 100 * (
-                gateway_net_amt(self.context.amount_auth))
-            if contr_agreement_student(student) == 'first':
-                # First agreement
-                xmldict['institution_acct'] = '0051005007'
-                xmldict['institution_bank_id'] = '31'
-            else:
-                # Second agreement
-                xmldict['institution_bank_id'] = '7'
-                xmldict['institution_acct'] = '1019763348'
-
-        # Lapel/File
-        elif self.context.p_category == 'lapel':
-            self.pay_item_id = '104'
-            xmldict['institution_amt'] = 100 * (
-                gateway_net_amt(self.context.amount_auth))
-
-        # Welfare Assurance
-        elif self.context.p_category == 'welfare':
-            self.pay_item_id = '105'
-            xmldict['institution_acct'] = '1006407792'
-            xmldict['institution_bank_id'] = '123'
-            xmldict['institution_amt'] = 100 * (
-                gateway_net_amt(self.context.amount_auth))
-
-        # ID Card
-        elif self.context.p_category == 'id_card':
-            self.pay_item_id = '000'
-            xmldict['institution_amt'] = 100 * (
-                gateway_net_amt(self.context.amount_auth))
-
-        # Matric Gown
-        elif self.context.p_category == 'matric_gown':
-            self.pay_item_id = '106'
-            xmldict['institution_amt'] = 100 * (
-                gateway_net_amt(self.context.amount_auth))
-
-        # Concessional
-        elif self.context.p_category == 'concessional':
-            self.pay_item_id = '107'
-            xmldict['institution_amt'] = 100 * (
-                gateway_net_amt(self.context.amount_auth))
-
-        # Hostel Maintenance
-        elif self.context.p_category == 'hostel_maintenance':
-            provider_amt = 500.0
-            self.pay_item_id = '109'
-            xmldict['institution_acct'] = '1006406795'
-            xmldict['institution_bank_id'] = '123'
-            xmldict['provider_amt'] = 100 * provider_amt
-            xmldict['institution_amt'] = 100 * (
-                gateway_net_amt(self.context.amount_auth) - provider_amt)
+        elif not xmltext:
             xmltext = """<payment_item_detail>
 <item_details detail_ref="%(detail_ref)s" college="%(institution_name)s" department="%(department)s" faculty="%(faculty)s">
